{% extends "navbarbase.html" %}

{% block indexcontent %}
<div class="row">
  <div class="leftcolumn">
    <table>
        <tr valign="top">
            <td><img src="{{ user.avatar(128) }}"></td>
            <td><h1>User: {{ user.username }}</h1></td>
            <br>
            <button class='btn btn-primary' id='start_download'>Download your data</button>
            <p id="status"></p>
            <p id="download"></p>
        </tr>
    </table>
  </div>
  <div class="rightcolumn">
      <h2>Questions</h2>
        {% if questions is defined %}
            {% for question in questions %}
                <div class="card">
                  <article class="media content-section">
                    <div class="media-body">
                      <div class="article-metadata">
                          <small class="text-muted">{{ question.timestamp.strftime('%Y-%m-%d') }}</small>
                          <small class="text-muted"><a href="{{url_for('updatequestion', questionid=question.id)}}">update</a></small>
                          <small class="text-muted"><a href="{{url_for('deletequestion', questionid=question.id)}}">delete</a></small>
                      </div>
                      <div>
                        {{question.body}}
                      </div>
                    </div>
                  </article>
                </div>
            {% endfor %}
        {% else %}
        <div class="card">
          <h3>No question</h3>
        </div>
        {% endif %}
        <br>
        <br>
        <h2>Answers</h2>
          {% if answers is defined %}
              {% for answer in answers %}
                  <div class="card">
                    <article class="media content-section">
                      <div class="media-body">
                        <div class="article-metadata">
                            <small class="text-muted">{{ answer.timestamp.strftime('%Y-%m-%d') }}</small>
                            <small class="text-muted"><a href="{{url_for('updateanswer', answerid=answer.id)}}">update</a></small>
                            <small class="text-muted"><a href="{{url_for('deleteanswer', answerid=answer.id)}}">delete</a></small>
                        </div>
                        <div>
                          {{answer.body}}
                        </div>
                      </div>
                    </article>
                  </div>
              {% endfor %}
          {% else %}
          <div class="card">
            <h3>No answer</h3>
          </div>
          {% endif %}
  </div>
</div>

{% endblock %}
{% block scripts %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.js"></script>
<script>
function update_progress(status_url) {
    // send GET request to status URL
    $.getJSON(status_url, function(data) {
        // update UI
        console.log("In update...");
        status = data['status']
        document.getElementById('status').innerHTML = status
        if (data['status'] != 'PENDING' && data['status'] != 'PROGRESS') {
            if ('filepath' in data) {
                // show result
                console.log(data['filepath']);
                document.getElementById('download').innerHTML = '<a href="/download/'+data['filepath']+'">Download</a>';
            }
            else {
                // something unexpected happened
                $('#download').text('Result: ' + data['state']);
            }
        }
        else {
            setTimeout(function() {
                update_progress(status_url);
            }, 1000);
        }
    });
}
$(document).ready(function() {

    function start_download() {
    // send ajax POST request to start background job
    $.ajax({
        type: 'POST',
        url: '/download',
        success: function(data, status, request) {
            status_url = request.getResponseHeader('Location');
            update_progress(status_url);
            console.log("In ajax");
            console.log(status_url);
        },
        error: function() {
            alert('Unexpected error');
        }
    });
}

    $('#start_download').click(start_download);
})

</script>
{% endblock %}
